/*************-//| 7a69Soft - http://www.7a69ezine.8m.com |\\****************
*  TILE: R-Bouncer v2.0                                                     *
*  CODER: Ripe - <ripe@mixmail.com>                                         *
*                                                                           *
*  TO COMPILE: cc g_bnc.c -o g_bnc                                          *
*                                                                           *
*  NOTE: Con la cantidad de bouncers que hay por ahi.... no se para que me  *
*        molesto :P                                                         *
*                                                                           *
*        Es posible que en fase de compilacion os aparezcan algunos         *
*        "warning", no os preocupeis por ello...                            *
*                                                                           *
*        Ahora estoy trabajando para aadirle algunas cosillas al bouncer,  *
*        y para mejorar un poco la presentacion del fichero log (que en     *
*        algunas ocasiones se hace incomodo de leer).                       *
*                                                                           *
****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <getopt.h>
#include <errno.h>

struct arguments {
   int puerto;
   char f_p;
   char *p;
   char f_l;
   char *l;
   char f_u;
   int u;
} args;

extern char *optarg;
extern int optind, opterr, optopt;

int view_help(char *cmd) {
   printf("\n\t\t7a69Soft - http://www.7a69ezine.8m.com\n");
   printf("\t\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n");
   printf("\t        R-Bouncer v2.0 By Ripe - <ripe@mixmail.com>\n\n");
   printf("Uso:\n");
   printf("\t%s <puerto> [opciones]\n", cmd);
   printf("Opciones:\n");
   printf("\t-p <password>\tEs necesario un password para usar R-Bouncer\n");
   printf("\t-l <fichero>\tGuarda en un fichero los accesos al bouncer\n");
   printf("\t-u <users>\tLimita el numero de usuarios simultaneos\n\n");
   exit(0);
}

int an_arguments(int argc, char **argv) {
   int argc_opt;
   int tmp;
   char ch;
   char **argv_opt;
   args.f_p=0;
   args.f_l=0;
   args.f_u=0;
   argv_opt=(char **)malloc(4*(argc-2));
   for (tmp=1 ; tmp<argc ; tmp++) {
      argv_opt[tmp-1]=(char*)malloc(strlen(argv[tmp])+1);
      strcpy(argv_opt[tmp-1], argv[tmp]);
   }
   argc_opt=argc-1;
   while ((ch=getopt(argc_opt, argv_opt, "p:l:u:"))!=EOF) {
      switch (ch) {
         case 'p': args.f_p=1;
                   args.p=(char *)malloc(strlen(optarg)+1);
	           strcpy(args.p, optarg);
	           break;
         case 'l': args.f_l=1;
	           args.l=(char *)malloc(strlen(optarg)+1);
                   strcpy(args.l, optarg);
   	           break;
         case 'u': args.f_u=1;
	           args.u=atoi(optarg);
	           break;
      }  
   } 
}

long resuelve(char *nom)
{
  long re;
  struct hostent *nm;
  re = inet_addr(nom);
  nm = gethostbyname(nom);
  if (re == -1) {
      if (nm != NULL) {
        bcopy(nm->h_addr,(char *)&re,nm->h_length);
        return re;
      }
  }
  return re;
}                                                                               

char **trans_argv(char *string, int *ptrargc) {
   int *nchs=NULL;
   int tmp, tmp2;
   int word;
   int desp;
   int argc;
   char *ptr;
   char **argv=NULL;
   argc=*ptrargc;
   argc=0;
   for (tmp=0 ; tmp<1024 ; tmp++) {
      if (string[tmp]==' ') argc++;
      if (string[tmp]==0) {
	 argc++;
	 break;
      }
   }
   if ((nchs=(int *)malloc(4*argc))==-1) falla(7);
   word=1;
   for (tmp=0 ; tmp<1024 ; tmp++) {
      if (string[tmp]==' ') {
	 word++;
	 nchs[word-1]=0;
      }
      if (string[tmp]==0) break;
      if (string[tmp]!=' ' && string[tmp]!=0) nchs[word-1]++;
      if (word>argc) break;
   }
   if ((argv=(char **)malloc(4*argc))==-1) falla(7);
   desp=0;
   for (tmp=0 ; tmp<argc ; tmp++) {
      if (tmp) desp=desp+nchs[tmp-1]+1;
      ptr=string+desp;
      if ((argv[tmp]=malloc(nchs[tmp]+1))==-1) falla(7);
      strncpy(argv[tmp], ptr, nchs[tmp]);
      if (tmp==argc-1) argv[tmp][(nchs[tmp]-2)]=0; 
   }
   *ptrargc=argc;
   return(argv);
}
   
void clearbuff(char *buff, int size) {
   for (size-1 ; size>=0 ; size--)
      buff[size]=NULL;
}

int falla(int code) {
   printf("ERROR: ");
   if (code==1) printf("socket()\n");
   if (code==2) printf("bind()\n");
   if (code==3) printf("listen()\n");
   if (code==4) printf("accept()\n");
   if (code==5) printf("connect()\n");
   if (code==6) printf("fork()\n");
   if (code==7) printf("malloc()\n");
   return(-code);
}
	 
int main(int argc, char **argv) {   
   int tmp;
   int fd;
   int cli_sfd=0;
   int serv_sfd;
   int serv_nsfd;
   int pid;
   int readed;
   int bnc_argc;
   int flags;
   int users=0;
   char read_buff[1024];
   char **bnc_argv;
   char bnc_cmd_good;
   char bnc_conected;
   char bnc_password_good;
   struct sockaddr_in cli;
   struct sockaddr_in serv;
   struct sockaddr_in user;
   if (argc<2) view_help(argv[0]);
   args.puerto=htons(atoi(argv[1]));
   if (argc>2) an_arguments(argc, argv);
   serv.sin_family=AF_INET;
   serv.sin_addr.s_addr=INADDR_ANY;
   serv.sin_port=args.puerto;
   cli.sin_family=AF_INET;
   cli.sin_addr.s_addr=NULL;
   cli.sin_port=NULL;
   if (args.f_l==1) {
      if ((fd=open(args.l, O_WRONLY | O_CREAT | O_TRUNC))==-1) args.f_l=0;
      else {
	 write(fd, "# R-Bouncer By Ripe - <ripe@mixmail.com>\n", 41);
	 write(fd, "# Starting Logfile....\n\n", 24);
      }
   }
   if ((serv_sfd=socket(AF_INET, SOCK_STREAM, 6))==-1) falla (1);
   if (bind(serv_sfd, &serv, sizeof(serv))==-1) falla(2);
   if (listen(serv_sfd, 5)==-1) falla(3);
   for (;;) {
      tmp=sizeof(user);
      if ((serv_nsfd=accept(serv_sfd, &user, &tmp))==-1) falla(4); 
      if (args.f_u) {
         users++;
         if (users>args.u) close(serv_nsfd);
      }
      if ((pid=fork())==-1) falla(6);
      if (pid==0) {
	 write(serv_nsfd, "R-Bouncer v2.0 By Ripe - <ripe@mixmail.com>\n", 44);         
         if (args.f_l==1) {
	    write(fd, inet_ntoa(user.sin_addr.s_addr), strlen(inet_ntoa(user.sin_addr.s_addr)));
	    write(fd, " <-> CONECTA\n", 13);
	    }
	 if (args.f_p==1) {
	    do {   		  
               bnc_password_good=0;
	       write(serv_nsfd, "Password: ", 10);
	       clearbuff(read_buff, 1024);
	       read(serv_nsfd, read_buff, 1024);
	       bnc_argv=trans_argv(read_buff, &bnc_argc); 
	       if (!strcmp(args.p, bnc_argv[0]) && bnc_argc==1) 
		  bnc_password_good=1;
               else {
	          write(serv_nsfd, "ERROR: Password incorrecto\n", 27);
		  if (args.f_l==1) {
		     write(fd, inet_ntoa(user.sin_addr.s_addr), strlen(inet_ntoa(user.sin_addr.s_addr)));
		     write(fd, " <-> PASSWORD ERROR\n", 20);
		  }
	       }
	    }
	    while (bnc_password_good==0);	    
	 }
         if (args.f_l==1) {
	     write(fd, inet_ntoa(user.sin_addr.s_addr), strlen(inet_ntoa(user.sin_addr.s_addr)));
	     write(fd, " <-> USING R-Bouncer\n", 21);
	 }
	 for (;;) {
            bnc_cmd_good=0;
	    bnc_conected=0;
	    write(serv_nsfd, "R-Bnc> ", 7);
            clearbuff(read_buff, 1024);
	    read(serv_nsfd, read_buff, 1024);
	    bnc_argv=trans_argv(read_buff, &bnc_argc);
	    if (!strcmp(bnc_argv[0], "help")) {
	       write(serv_nsfd, "R-Bouncer v2.0 By Ripe - <ripe@mixmail.com>\n", 44);
	       write(serv_nsfd, "\n", 1);
               write(serv_nsfd, "\texit - Te desconecta del bouncer\n", 34);
               write(serv_nsfd, "\thelp - Pues muesta lo que estas viendo ahora ;)\n", 49);
	       write(serv_nsfd, "\tserv <IP/HOST> <PORT> - Conecta al servidor\n", 45);
               bnc_cmd_good=1;
            }
	    if (!strcmp(bnc_argv[0], "exit")) {
	       write(serv_nsfd, "Desconectado...\n", 16);
	       close(serv_nsfd);
	       if (cli_sfd!=0) close(cli_sfd);
	       bnc_cmd_good=1;
	       kill(getpid(), 9);
	    }
	    if (!strcmp(bnc_argv[0], "serv")) {
	       if (bnc_argc<3) write(serv_nsfd, "Uso incorrecto de 'serv', consulta 'help'\n", 42);
               else {
		  cli.sin_addr.s_addr=resuelve(bnc_argv[1]);
		  cli.sin_port=htons(atoi(bnc_argv[2]));
		  write(serv_nsfd, "Conectando...\n", 14);
		  if ((cli_sfd=socket(AF_INET, SOCK_STREAM, 6))==-1) 
		     write(serv_nsfd, "Imposible conectar :-?\n", 23);
		  else {
		     if (connect(cli_sfd, &cli, sizeof(cli))==-1)
		        write(serv_nsfd, "Imposible conectar :-?\n", 23);
		     else {
		        write(serv_nsfd, "Conectado :)\n", 13);
		        bnc_conected=1;		        
                        if (args.f_l==1) {
			   write(fd, inet_ntoa(user.sin_addr.s_addr), strlen(inet_ntoa(user.sin_addr.s_addr)));
			   write(fd, " <CONECTED> ", 12);
			   write(fd, inet_ntoa(cli.sin_addr.s_addr), strlen(inet_ntoa(cli.sin_addr.s_addr))); 
			   write(fd, "\n", 1);
			}
		     }
		  }
	       }
	       bnc_cmd_good=1;
	    }
            if (bnc_cmd_good!=1) write(serv_nsfd, "Comando incorrecto, usa 'help' para mas informacion\n", 52); 
	    if (bnc_conected==1) break;
	 }
         flags=fcntl(serv_nsfd, F_GETFL);
         fcntl(serv_nsfd, F_SETFL, flags | O_NONBLOCK);
         flags=fcntl(cli_sfd, F_GETFL);
         fcntl(cli_sfd, F_SETFL, flags | O_NONBLOCK);
         for (;;) {
	    clearbuff(read_buff, 1024);
	    if ((readed=read(serv_nsfd, read_buff, 1024))>0) {
	       write(cli_sfd, read_buff, readed);
	       if (args.f_l==1) {
		  write(fd, inet_ntoa(user.sin_addr.s_addr), strlen(inet_ntoa(user.sin_addr.s_addr)));
		  write(fd, " <SEND> ", 8);
		  write(fd, read_buff, readed);
		  write(fd, "\n", 1);
	       }
	    }
	    clearbuff(read_buff, 1024);
	    if ((readed=read(cli_sfd, read_buff, 1024))>0) {
	       write(serv_nsfd, read_buff, readed);
	       if (args.f_l==1) {
		  write(fd, inet_ntoa(user.sin_addr.s_addr), strlen(inet_ntoa(user.sin_addr.s_addr)));
		  write(fd, " <RECIVE> ", 10);
		  write(fd, read_buff, readed);
		  write(fd, "\n", 1);
	       }
	    }
	 }
      }
   }
}


               /* 7a69Soft - http://www.7a69ezine.8m.com */
