/*************-//| 7a69Soft - http://www.7a69ezine.8m.com |\\-***************
*                                                                           *
*  TILE: Sokobantext v1.0b1                                                 *
*  CODER: Ripe - <ripe@mixmail.com>                                         *
*                                                                           *
*  TO COMPILE: gcc -lncurses sokobantext.c -o sokoban                       *
*                                                                           *
*  NOTE: De momento solo version beta.... creo que me dejo un par de fallos *
*        que he de buscar ;->                                               *
*                                                                           *
*        Para mas informacion leer readme.txt                               *
*                                                                           *
****************************************************************************/

#include <stdio.h>   
#include <stdlib.h>
#include <string.h>
#include <unistd.h>  
#include <fcntl.h>
#include <ncurses.h>

#define RC 0xa
#define FD_KEYBOARD 0
#define KEY_UP_ 0x41
#define KEY_DOWN_ 0x42
#define KEY_LEFT_ 0x43  
#define KEY_RIGTH_ 0x44  

struct fmap {
    unsigned long int size;
    unsigned char nummaps;
    unsigned char nummap;
    int handle;
    unsigned activemap[20][80];
    unsigned char iny;
    unsigned char inx;
} map;

void wait(unsigned int time) {
    int tmp;
    time=time*5000;
    for (tmp=0 ; tmp<time ; tmp++) {
        tmp++;
        tmp--;
    }
}

void crlscr(void) {
    system("clear");
}

void draw(int *pnty, int *pntx, char *caracter, int punts, char rfsh) {
    int tmp;
    for (tmp=0 ; tmp<=punts ; tmp++) {
        mvaddch(pnty[tmp], pntx[tmp], caracter[tmp]);
        if (rfsh!=0) {
            wait(rfsh);
            refresh();
        }
    }
    if (rfsh==0)
        refresh();
}

an_arguments(int argc, char *argv[]) {
    char filename[256];    
    int tmp;
    int error=-1;    
    char done=0;
    for (tmp=1 ; tmp<argc ; tmp++) {
        if (!strcmp(argv[tmp],"--map")) {
            done=1;
            if (tmp!=(argc-1)) {                 
                strcpy(filename,argv[tmp+1]);
                error=load_filemap(filename);
                if (error<0) {
                    strcpy(filename, "default.map");
                    error=load_filemap(filename);
                }      
            }
            else {
                printf("Uso incorrecto de --map (Uso: --map <fichero>)\n");
                map.handle=-1;
            }
        }
        else 
           if (strcmp(argv[tmp-1],"--map"))
               printf("Opcion invalida: %s\n",argv[tmp]);
    }
    if (done!=1) {
        strcpy(filename, "default.map");
        error=load_filemap(filename);
    }
    return(error);    
}             
    
load_filemap(char *filename) {
    char buffer[10];
    int tmp, needsize;	
    printf("Cargando fichero de mapas: %s",filename);
    if(0>(map.handle=open(filename, O_RDONLY))) 
        printf("   [ERROR]1\n");
    else {
        printf("   [DONE]\n");
        printf("Comprobando integridad del fichero");
        if(9!=read(map.handle, buffer, 9)) {
            printf("   [ERROR]2\n");
            close(map.handle);
            map.handle=-1;
        }
        else {
            if (!strcmp(buffer, "MxrRxtzzA")) {
                printf("   [ERROR]3\n");
                close(map.handle);
                map.handle=-1;
            }
            else {
                if(1!=read(map.handle, &map.nummaps, 1)) {
                    printf("   [ERROR]4\n");
                    close(map.handle);
                    map.handle=-1;
                }
                else {
                    map.nummaps=map.nummaps-40;                
                    if((map.size=lseek(map.handle, 0, SEEK_END))<(needsize=10+map.nummaps*1600)) {
                        printf("   [ERROR]5\n");
                        close(map.handle);
                        map.handle=-1;
                    }
                    else {
                        lseek(map.handle, 10, SEEK_SET);
                        for(tmp=11 ; tmp<(map.nummaps*1600) ; tmp++) {
                            read(map.handle, buffer, 1);
                            buffer[0]=buffer[0]-40;          
                            if (buffer[0]!=0 && buffer[0]!=1 && buffer[0]!=2 && buffer[0]!=4 && buffer[0]!=8)
                                map.nummaps=0;
                        }
                        if (map.nummaps==0) {
                            printf("   [ERROR]6\n");
                            close(map.handle);
                            map.handle=-1;
                        }
                    }
                }
            } 
        }               
    }         
    return(map.handle);
}

void presentacion(void) {
    int tmp, flags, key;
    int punty[]={4,4,4,4,4,4,4,4,4,4,4,5,5,5,5,5,5,5,5,5,5,5,6,6,6,7,7,7,8,8,8,8,8,8,8,8,8,8,8,9,9,9,9,9,9,9,9,9,9,9,10,10,10,11,11,11,12,12,12,12,12,12,12,12,12,12,12,13,13,13,13,13,13,13,13,13,13,13,
                 7,7,7,7,7,7,8,8,8,8,8,8,8,8,9,9,9,9,9,9,10,10,10,10,10,10,11,11,11,11,11,11,12,12,12,12,12,12,12,12,13,13,13,13,13,13,
                 7,7,7,7,7,8,8,8,8,8,9,9,9,9,9,9,10,10,10,10,10,10,11,11,11,11,11,11,12,12,12,12,12,13,13,13,13,13,
                 7,7,7,7,7,7,8,8,8,8,8,8,8,8,9,9,9,9,9,9,10,10,10,10,10,10,11,11,11,11,11,11,12,12,12,12,12,12,12,12,13,13,13,13,13,13,
 		 5,5,5,6,6,6,7,7,7,8,8,8,9,9,9,9,9,9,9,10,10,10,10,10,10,10,10,10,11,11,11,11,11,11,12,12,12,12,12,12,12,12,13,13,13,13,13,13,13,
                 7,7,7,7,7,7,8,8,8,8,8,8,8,8,9,9,9,10,10,10,10,10,10,10,10,11,11,11,11,11,11,12,12,12,12,12,12,12,12,12,13,13,13,13,13,13,
                 7,7,7,7,7,7,8,8,8,8,8,8,8,9,9,9,9,9,9,9,9,10,10,10,10,10,10,10,10,11,11,11,11,11,11,11,11,12,12,12,12,12,12,12,13,13,13,13,13,13};
    int puntx[]={1,2,3,4,5,6,7,8,9,10,11,1,2,3,4,5,6,7,8,9,10,11,1,2,3,1,2,3,1,2,3,4,5,6,7,8,9,10,11,1,2,3,4,5,6,7,8,9,10,11,9,10,11,9,10,11,1,2,3,4,5,6,7,8,9,10,11,1,2,3,4,5,6,7,8,9,10,11,
                 15,16,17,18,19,20,14,15,16,17,18,19,20,21,13,14,15,20,21,22,13,14,15,20,21,22,13,14,15,20,21,22,14,15,16,17,18,19,20,21,15,16,17,18,19,20,
                 24,25,26,30,31,24,25,26,29,30,24,25,26,28,29,30,24,25,26,27,28,29,24,25,26,29,30,31,24,25,26,30,31,24,25,26,31,32,
                 35,36,37,38,39,40,34,35,36,37,38,39,40,41,33,34,35,40,41,42,33,34,35,40,41,42,33,34,35,40,41,42,34,35,36,37,38,39,40,41,35,36,37,38,39,40,
                 45,46,47,45,46,47,45,46,47,45,46,47,45,46,47,48,49,50,51,45,46,47,48,49,50,51,52,53,45,46,47,51,52,53,45,46,47,48,49,50,51,52,45,46,47,48,49,50,51,
                 56,57,58,59,60,61,55,56,57,58,59,60,61,62,61,62,63,56,57,58,59,60,61,62,63,55,56,57,61,62,63,55,56,57,58,59,60,61,62,63,56,57,58,59,60,61,
                 66,67,68,73,74,75,66,67,68,69,73,74,75,66,67,68,69,70,73,74,75,66,67,68,70,71,73,74,75,66,67,68,71,72,73,74,75,66,67,68,72,73,74,75,66,67,68,73,74,75};
    int punts=353;
    char caracter[]="#################################################################################################################################################################################################################################################################################################################################################################";
    draw(punty, puntx, caracter, punts, 0);
    mvaddstr(14, 73, "TEXT");
    flags=fcntl(FD_KEYBOARD, F_GETFL);
    fcntl(FD_KEYBOARD, F_SETFL, flags | O_NONBLOCK);
    mvaddstr(0, 0, "7A69soft - <2000>");
    mvaddstr(0, 54, "Sokobantext v1.0b1 By Ripe");
    refresh();
    do {      
       mvaddstr(22, 34, "Press [ENTER]");
       move(24, 79);
       refresh();       
       wait(1500);
       mvaddstr(22, 34, "             ");
       move(24, 79);
       refresh();        
       wait(700);
    }
    while(getch()!=RC);
    fcntl(FD_KEYBOARD, F_SETFL, flags);
}

char menu(unsigned char opt) {    
    unsigned long int key;
    unsigned char tmp;
    for (tmp=1 ; tmp<25 ; tmp++)
        mvaddstr(tmp, 0,"                                                                                ");     
    mvaddstr(1, 0, "--------------------------------------------------------------------------------");
    mvaddstr(7, 33, "Empezar juego");
    mvaddstr(11, 35, "Creditos");
    mvaddstr(15, 33, "Info 7a69soft");
    mvaddstr(19, 37, "Salir");
    do {
        mvaddstr(7, 31, " ");
        mvaddstr(7, 47, " ");
        mvaddstr(11, 33, " ");
        mvaddstr(11, 44, " ");
        mvaddstr(15, 31, " ");
        mvaddstr(15, 47, " ");
        mvaddstr(19, 35, " ");
        mvaddstr(19, 43, " ");
        switch (opt) {
            case 1: mvaddstr(7, 31, "[");
                    mvaddstr(7, 47, "]");
                    break;
            case 2: mvaddstr(11, 33, "[");
                    mvaddstr(11, 44, "]");
                    break;
            case 3: mvaddstr(15, 31, "[");
                    mvaddstr(15, 47, "]");
                    break;
            case 4: mvaddstr(19, 35, "[");
                    mvaddstr(19, 43, "]");
                    break;
        }              
        move(24, 79);
        refresh();
	key=getch();
	if (key==KEY_UP_) {
            opt=opt-1;
            if (opt==0)
                opt=1;
        }
        if (key==KEY_DOWN_) {
            opt=opt+1;
            if (opt==5)
                opt=4;
        }
    }
    while(key!=RC);
    for (tmp=2 ; tmp<25 ; tmp++)
        mvaddstr(tmp, 0,"                                                                                "); 
    return(opt);
}

unsigned char printmap(void) {   
    unsigned char posy, posx;    
    unsigned char win1=1;
    unsigned char win2=1;
    for (posy=0 ; posy<20 ; posy++) {
        for(posx=0 ; posx<80 ; posx++) {
           switch(map.activemap[posy][posx]) {
                case 0: mvaddch(posy+2, posx, ' ');
                        break; 
                case 1: mvaddch(posy+2, posx, '#');
                        break;
                case 2: mvaddch(posy+2, posx, '*');
                        break;
                case 4: mvaddch(posy+2, posx, '0');
                        map.iny=posy;
                        map.inx=posx;
                        break;
                case 8: mvaddch(posy+2, posx, '@');               
                        win1=0;                      
                        break;                   
                case 10: mvaddch(posy+2, posx, '*');
                         break;
                case 12: mvaddch(posy+2, posx, '0');
                         win2=0;
                         break;
            }
        }
    }
    move(24,79);
    refresh();
    if (win1==1 && win2==1)
        return(1);
    else
        return(0);
}

void quit_game(void) {
    endwin();
    crlscr();
}

main(int argc, char *argv[]) {
    int tmp;
    unsigned int moves;
    unsigned char ay=0;
    unsigned char ax=0;    
    unsigned char activemap_[1600];
    unsigned char opt, key, win;
    an_arguments(argc, argv);    
    if (map.handle<0)
       return(-1);  
    printf("   [DONE]\n");
    initscr();
    endwin();
    printf("Compobando tamao del terminal");      
    if (LINES<25 || COLS<80) {
        printf("   [ERROR]\n");
        return(-1);
    }
    printf("   [DONE]\n");   
    initscr();
    noecho();  
    presentacion();
    opt=1;
MENU:
    opt=menu(opt);  
    if (opt==4) {
        endwin();
        crlscr();
        return(0);
    } 
    if (opt==3) {
        mvaddstr(2, 27, "|-<< INFO 7A69SOFT >>-|");
        mvaddstr(3, 27, "^^^^^^^^^^^^^^^^^^^^^^^");
        mvaddstr(5, 10, "7A69 es un grupo de genete que tiene inquietudes sobre la");
        mvaddstr(6, 7, "informatica, y especialmente en el campo de la seguridad.");
        mvaddstr(8, 10, "7A69SOFT es uno de los proyectos de 7A69 mediante el que los");
        mvaddstr(9, 7, "componentse del Staff de 7A69 tratan de hacer llegar codigos de");
        mvaddstr(10, 7, "dibersas aplicaciones a aquellos que se quieran iniciar en el");
        mvaddstr(11, 7, "mundo de la programacion, al mismo tiempo que proporciona");
        mvaddstr(12, 7, "aplicaiones utiles y/o dibertidas.");   
        mvaddstr(14, 10, "Otro proyecto de 7A69 es 7A69EZINE (que de echo es el");
        mvaddstr(15, 7, "proyecto principal de 7A69), y del que puedes encontrar los");
        mvaddstr(16, 7, "resultados en http://www.7a69ezine.8m.com");
        mvaddstr(18, 10, "Para alguna sugerencia, queja, o fallo en alguno de nuestros");        
        mvaddstr(19, 7, "porgramas: 7a69ezine@mixmail.com");    
        move(24, 79);
        refresh(); 
        do{
           wait(100);
        }
        while(getch()!=RC);
        goto MENU;
    }    
    if (opt==2) {
        mvaddstr(2, 30, "|-<< CREDITOS >>-|");
        mvaddstr(5, 35, "-Ideas-");
        mvaddstr(7, 26, "Ripe -< ripe@mixmail.com >-");
        mvaddstr(10, 32, "-Programacion-");
        mvaddstr(12, 26, "Ripe -< ripe@mixmail.com >-");
        mvaddstr(15, 35, "-Diseo-");
        mvaddstr(17, 26, "Ripe -< ripe@mixmail.com >-");
        mvaddstr(20, 32, "-Colaboracion-");
        mvaddstr(22, 24, "Doing -< jdoing@bigfoot.com >-"); 
        move(24, 79);
        refresh();
        do {
            wait(100);
        }
        while(getch()!=RC);
        goto MENU;
    }
    for (map.nummap=1 ; map.nummaps>=map.nummap ; map.nummap++) {
        lseek(map.handle, 9+((map.nummap-1)*1600), SEEK_SET);
        for (tmp=0 ; (tmp+10)<map.size ; tmp++)
           read(map.handle, &activemap_[tmp], 1); 
        tmp=0;
        for (ay=0 ; ay<20 ; ay++) {
            for(ax=0 ; ax<80 ; ax++) {
                tmp++;
                map.activemap[ay][ax]=(activemap_[tmp]-40);
            }
        }
        for(moves=0 ; ; ) {
            win=printmap();    
            if (win==1)
                break;
            key=getch();
            if (key==KEY_UP_) {
                if(map.activemap[map.iny-1][map.inx]==0 || map.activemap[map.iny-1][map.inx]==8) { 
                    map.activemap[map.iny][map.inx]=map.activemap[map.iny][map.inx]-4;
                    map.activemap[map.iny-1][map.inx]=map.activemap[map.iny-1][map.inx]+4;
                    map.iny=map.iny-1;
                    moves++;
                }
                else {
                    if ((map.activemap[map.iny-1][map.inx]==2 || map.activemap[map.iny-1][map.inx]==10) && (map.activemap[map.iny-2][map.inx]==8 || map.activemap[map.iny-2][map.inx]==0)) {
                        map.activemap[map.iny][map.inx]=map.activemap[map.iny][map.inx]-4;
                        map.activemap[map.iny-1][map.inx]=map.activemap[map.iny-1][map.inx]+4;
                        map.activemap[map.iny-1][map.inx]=map.activemap[map.iny-1][map.inx]-2;
                        map.activemap[map.iny-2][map.inx]=map.activemap[map.iny-2][map.inx]+2;
                        map.iny=map.iny-1; 
                        moves++;
                    }
                }
            }
            if (key==KEY_DOWN_) {
                if(map.activemap[map.iny+1][map.inx]==0 || map.activemap[map.iny+1][map.inx]==8) { 
                    map.activemap[map.iny][map.inx]=map.activemap[map.iny][map.inx]-4;
                    map.activemap[map.iny+1][map.inx]=map.activemap[map.iny+1][map.inx]+4;
                    map.iny=map.iny+1;
                    moves++;
                }
                else {
                    if ((map.activemap[map.iny+1][map.inx]==2 || map.activemap[map.iny+1][map.inx]==10) && (map.activemap[map.iny+2][map.inx]==8 || map.activemap[map.iny+2][map.inx]==0)) {
                        map.activemap[map.iny][map.inx]=map.activemap[map.iny][map.inx]-4;
                        map.activemap[map.iny+1][map.inx]=map.activemap[map.iny+1][map.inx]+4;
                        map.activemap[map.iny+1][map.inx]=map.activemap[map.iny+1][map.inx]-2;
                        map.activemap[map.iny+2][map.inx]=map.activemap[map.iny+2][map.inx]+2;
                        map.iny=map.iny+1; 
                        moves++;
                    }
                }      
            }
            if (key==KEY_RIGTH_) {
                if(map.activemap[map.iny][map.inx-1]==0 || map.activemap[map.iny][map.inx-1]==8) {
                    map.activemap[map.iny][map.inx]=map.activemap[map.iny][map.inx]-4;
                    map.activemap[map.iny][map.inx-1]=map.activemap[map.iny][map.inx-1]+4;
                    map.inx=map.inx-1;
                    moves++;
                }
                else {
                    if ((map.activemap[map.iny][map.inx-1]==2 || map.activemap[map.iny][map.inx-1]==10) && (map.activemap[map.iny][map.inx-2]==0 || map.activemap[map.iny][map.inx-2]==8)) {
                        map.activemap[map.iny][map.inx]=map.activemap[map.iny][map.inx]-4;
                        map.activemap[map.iny][map.inx-1]=map.activemap[map.iny][map.inx-1]+4;
                        map.activemap[map.iny][map.inx-1]=map.activemap[map.iny][map.inx-1]-2;
                        map.activemap[map.iny][map.inx-2]=map.activemap[map.iny][map.inx-2]+2;
                        map.inx=map.inx-1;
                        moves++; 
                    }
                }
            }
            if (key==KEY_LEFT_) {
                if(map.activemap[map.iny][map.inx+1]==0 || map.activemap[map.iny][map.inx+1]==8) {
                    map.activemap[map.iny][map.inx]=map.activemap[map.iny][map.inx]-4;
                    map.activemap[map.iny][map.inx+1]=map.activemap[map.iny][map.inx+1]+4;
                    map.inx=map.inx+1;
                    moves++;
                }
                else {
                    if ((map.activemap[map.iny][map.inx+1]==2 || map.activemap[map.iny][map.inx+1]==10) && (map.activemap[map.iny][map.inx+2]==0 || map.activemap[map.iny][map.inx+2]==8)) {
                        map.activemap[map.iny][map.inx]=map.activemap[map.iny][map.inx]-4;
                        map.activemap[map.iny][map.inx+1]=map.activemap[map.iny][map.inx+1]+4;
                        map.activemap[map.iny][map.inx+1]=map.activemap[map.iny][map.inx+1]-2;
                        map.activemap[map.iny][map.inx+2]=map.activemap[map.iny][map.inx+2]+2;
                        map.inx=map.inx+1;
                        moves++;
                    }
                }
            }
            if (key=='q') {
               quit_game();       
               return(0);
            }
        }           
        for (tmp=21 ; tmp<25 ; tmp++)
            mvaddstr(tmp, 0,"                                                                                ");   
        mvaddstr(22, 20, "------------------------------------");
        mvaddstr(23, 20, "|    Nivel Completado con exito    |");
        mvaddstr(24, 20, "------------------------------------");
        move(24, 79);
        refresh();      
        getch();
        for (tmp=21 ; tmp<25 ; tmp++) 
            mvaddstr(tmp, 0,"                                                                                ");       
    }
    quit_game();
    printf("\t\t\t\tEnoraBuena!!\n\n");
    printf("\tHas conseguido completar con exito todos los niveles contenidos\n"); 
    printf("\ten este fichero de mapas\n\n\n");
    return(0);
}



                /* 7a69Soft - http://www.7a69ezine.8m.com */
